clear

mkdir('RandomSplits')

% load positive images
posImageNames = dir('posAll/*.jpg');
% load negative images
negImageNames = dir('negAll/*.jpg');

nTrain = 10; nTest = 160;

for run = 1:5
    % randomly assign 40 positive images to training
    perm = randperm(length(posImageNames));
    posTrainImages = cell(1,nTrain);
    for i = 1:nTrain
        posTrainImages{i} = posImageNames(perm(i)).name;
    end
    % assign the rest positive images to testing
    posTestImages = cell(1,length(posImageNames)-nTrain);
    for i = 1:length(posTestImages)
        posTestImages{i} = posImageNames(perm(i+nTrain)).name;
    end
    
    % randomly assign nTest negative images to training
    perm = randperm(length(negImageNames));
    negTrainImages = cell(1,nTest);
    for i = 1:nTest
        negTrainImages{i} = negImageNames(perm(i)).name;
    end
    % assign the rest positive images to testing
    negTestImages = cell(1,length(negImageNames)-nTest);
    for i = 1:length(negTestImages)
        negTestImages{i} = negImageNames(perm(i+nTest)).name;
    end
    
    save(sprintf('RandomSplits/split%d.mat',run),'negTestImages',...
        'negTrainImages','posTrainImages','posTestImages');
end

nTrain = 20; nTest = 160;

for run = 6:10
    % randomly assign 40 positive images to training
    perm = randperm(length(posImageNames));
    posTrainImages = cell(1,nTrain);
    for i = 1:nTrain
        posTrainImages{i} = posImageNames(perm(i)).name;
    end
    % assign the rest positive images to testing
    posTestImages = cell(1,length(posImageNames)-nTrain);
    for i = 1:length(posTestImages)
        posTestImages{i} = posImageNames(perm(i+nTrain)).name;
    end
    
    % randomly assign nTest negative images to training
    perm = randperm(length(negImageNames));
    negTrainImages = cell(1,nTest);
    for i = 1:nTest
        negTrainImages{i} = negImageNames(perm(i)).name;
    end
    % assign the rest positive images to testing
    negTestImages = cell(1,length(negImageNames)-nTest);
    for i = 1:length(negTestImages)
        negTestImages{i} = negImageNames(perm(i+nTest)).name;
    end
    
    save(sprintf('RandomSplits/split%d.mat',run),'negTestImages',...
        'negTrainImages','posTrainImages','posTestImages');
end


nTrain = 40; nTest = 160;

for run = 11:15
    % randomly assign 40 positive images to training
    perm = randperm(length(posImageNames));
    posTrainImages = cell(1,nTrain);
    for i = 1:nTrain
        posTrainImages{i} = posImageNames(perm(i)).name;
    end
    % assign the rest positive images to testing
    posTestImages = cell(1,length(posImageNames)-nTrain);
    for i = 1:length(posTestImages)
        posTestImages{i} = posImageNames(perm(i+nTrain)).name;
    end
    
    % randomly assign nTest negative images to training
    perm = randperm(length(negImageNames));
    negTrainImages = cell(1,nTest);
    for i = 1:nTest
        negTrainImages{i} = negImageNames(perm(i)).name;
    end
    % assign the rest positive images to testing
    negTestImages = cell(1,length(negImageNames)-nTest);
    for i = 1:length(negTestImages)
        negTestImages{i} = negImageNames(perm(i+nTest)).name;
    end
    
    save(sprintf('RandomSplits/split%d.mat',run),'negTestImages',...
        'negTrainImages','posTrainImages','posTestImages');
end

nTrain = 80; nTest = 160;

for run = 16:20
    % randomly assign 80 positive images to training
    perm = randperm(length(posImageNames));
    posTrainImages = cell(1,nTrain);
    for i = 1:nTrain
        posTrainImages{i} = posImageNames(perm(i)).name;
    end
    % assign the rest positive images to testing
    posTestImages = cell(1,length(posImageNames)-nTrain);
    for i = 1:length(posTestImages)
        posTestImages{i} = posImageNames(perm(i+nTrain)).name;
    end
    
    % randomly assign nTest negative images to training
    perm = randperm(length(negImageNames));
    negTrainImages = cell(1,nTest);
    for i = 1:nTest
        negTrainImages{i} = negImageNames(perm(i)).name;
    end
    % assign the rest positive images to testing
    negTestImages = cell(1,length(negImageNames)-nTest);
    for i = 1:length(negTestImages)
        negTestImages{i} = negImageNames(perm(i+nTest)).name;
    end
    
    save(sprintf('RandomSplits/split%d.mat',run),'negTestImages',...
        'negTrainImages','posTrainImages','posTestImages');
end


nTrain = 5; nTest = 160;

for run = 21:25
    % randomly assign 5 positive images to training
    perm = randperm(length(posImageNames));
    posTrainImages = cell(1,nTrain);
    for i = 1:nTrain
        posTrainImages{i} = posImageNames(perm(i)).name;
    end
    % assign the rest positive images to testing
    posTestImages = cell(1,length(posImageNames)-nTrain);
    for i = 1:length(posTestImages)
        posTestImages{i} = posImageNames(perm(i+nTrain)).name;
    end
    
    % randomly assign nTest negative images to training
    perm = randperm(length(negImageNames));
    negTrainImages = cell(1,nTest);
    for i = 1:nTest
        negTrainImages{i} = negImageNames(perm(i)).name;
    end
    % assign the rest positive images to testing
    negTestImages = cell(1,length(negImageNames)-nTest);
    for i = 1:length(negTestImages)
        negTestImages{i} = negImageNames(perm(i+nTest)).name;
    end
    
    save(sprintf('RandomSplits/split%d.mat',run),'negTestImages',...
        'negTrainImages','posTrainImages','posTestImages');
end

